/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/* $Source: src/import/chips/centaur/procedures/hwp/memory/fapiTestHwpDq.H $ */
/*                                                                        */
/* OpenPOWER HostBoot Project                                             */
/*                                                                        */
/* Contributors Listed Below - COPYRIGHT 2016,2017                        */
/* [+] International Business Machines Corp.                              */
/*                                                                        */
/*                                                                        */
/* Licensed under the Apache License, Version 2.0 (the "License");        */
/* you may not use this file except in compliance with the License.       */
/* You may obtain a copy of the License at                                */
/*                                                                        */
/*     http://www.apache.org/licenses/LICENSE-2.0                         */
/*                                                                        */
/* Unless required by applicable law or agreed to in writing, software    */
/* distributed under the License is distributed on an "AS IS" BASIS,      */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or        */
/* implied. See the License for the specific language governing           */
/* permissions and limitations under the License.                         */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
///
/// @file fapiTestHwpDq.H
/// @brief Test Hardware Procedure that exercises the bad DQ data
///
/// *HWP HWP Owner: Luke Mulkey <lwmulkey@us.ibm.com>
/// *HWP HWP Backup: Andre Marin <aamarin@us.ibm.com>
/// *HWP Team: Memory
/// *HWP Level: 2
/// *HWP Consumed by: HB:CI
///


#ifndef FAPITESTHWPDQ_H_
#define FAPITESTHWPDQ_H_

#include <fapi2.H>

typedef fapi2::ReturnCode (*fapi2TestHwpDq_FP_t)(const fapi2::Target<fapi2::TARGET_TYPE_MBA>&);

extern "C"
{

    ///
    /// @brief Test Hardware Procedure that exercises the bad DQ data
    /// @param[in] i_mba Reference to MBA chiplet
    /// @return ReturnCode
    ///
    fapi2::ReturnCode fapi2TestHwpDq(const fapi2::Target<fapi2::TARGET_TYPE_MBA>& i_mba);

}

#endif
