/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/* $Source: src/include/usr/util/utilcommonattr.H $                       */
/*                                                                        */
/* OpenPOWER HostBoot Project                                             */
/*                                                                        */
/* Contributors Listed Below - COPYRIGHT 2017                             */
/* [+] International Business Machines Corp.                              */
/*                                                                        */
/*                                                                        */
/* Licensed under the Apache License, Version 2.0 (the "License");        */
/* you may not use this file except in compliance with the License.       */
/* You may obtain a copy of the License at                                */
/*                                                                        */
/*     http://www.apache.org/licenses/LICENSE-2.0                         */
/*                                                                        */
/* Unless required by applicable law or agreed to in writing, software    */
/* distributed under the License is distributed on an "AS IS" BASIS,      */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or        */
/* implied. See the License for the specific language governing           */
/* permissions and limitations under the License.                         */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
#ifndef UTILCOMMONATTR_H
#define UTILCOMMONATTR_H

/**
 * @file utilcommonattr.H
 *
 * @brief   Common attribute interfaces shared between components
 *
 */

/*****************************************************************************/
// I n c l u d e s
/*****************************************************************************/
#include <stdint.h>
#include <errl/errlentry.H>

#include <targeting/common/target.H>

namespace Util
{

    /**
     * @brief Get the OBUS PLL bucket that corresponds to index and target
     * @param[in] i_chipTarget      Target pointer to chip
     * @param[out] i_o_bucket_val   corresponding number in PLL frequency list
     * @param[in] i_index           The index number of the OBUS (0,1,2,3)
     *
     * @return errlHndl_t        Error log if unable to get bucket value
     */
    errlHndl_t getObusPllBucket(TARGETING::Target * i_chipTarget,
                                uint8_t &o_bucket_val,
                                const uint8_t i_index);

}; // namespace Util

#endif // UTILCOMMONATTR_H
