/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/* $Source: src/include/usr/util/utilxipimage.H $                         */
/*                                                                        */
/* OpenPOWER HostBoot Project                                             */
/*                                                                        */
/* Contributors Listed Below - COPYRIGHT 2017                             */
/* [+] International Business Machines Corp.                              */
/*                                                                        */
/*                                                                        */
/* Licensed under the Apache License, Version 2.0 (the "License");        */
/* you may not use this file except in compliance with the License.       */
/* You may obtain a copy of the License at                                */
/*                                                                        */
/*     http://www.apache.org/licenses/LICENSE-2.0                         */
/*                                                                        */
/* Unless required by applicable law or agreed to in writing, software    */
/* distributed under the License is distributed on an "AS IS" BASIS,      */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or        */
/* implied. See the License for the specific language governing           */
/* permissions and limitations under the License.                         */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/**
 *  @file util/utilxipimage.H
 *
 *  @brief Provides utility functions for XIP images.
 */
#ifndef __UTIL_XIP_IMAGE_H
#define __UTIL_XIP_IMAGE_H

//******************************************************************************
// Includes
//******************************************************************************
#include <trace/interface.H>

namespace Util
{

    /**
     *  @brief Structure for XIP image build information
     */
    struct imageBuild_t
    {
        uint32_t buildDate;    // Generated by `date +%Y%m%d`, eg, 20110630
        uint32_t buildTime;    // Generated by `date +%H%M`, eg, 0756
        char     buildTag[20]; // Generated when releasing image to fw
    } PACKED;

    /**
     *  @brief Pull build information from XIP header and trace it.
     * @param[in]  i_imagePtr   Pointer to image with XIP header.
     *
     * @param[out] o_imageBuild Build information for input image.
     *
     * @param[in]  i_traceDesc  Trace descriptor for trace buffer to use.
     *                          Defaults to nullptr and not tracing.
     */
    void pullTraceBuildInfo(void* i_imagePtr,
                            imageBuild_t& o_imageBuild,
                            trace_desc_t* i_traceDesc = nullptr);
}

#endif